/*

GOAL
create a 4x4 grid of 16 squares

0. define a minimum (0) and maximum (4)
1. define 4 rows across (loop #1)
2. within each row, define 4 columns (loop #2)
3. for each column, add a square to the grid (addSquare function)
	a. for all diagonal squares starting at top left and ending at bottom right, class = .demo-circle
	b. for all corner squares, class = .demo-square
	c. for even numbered columns, class = .demo-stripe
	d. * NEW! * for odd numbered columns, class = .demo-lozenge

*/ 


// 0. define a minimum (0) and maximum (4)
var min = 0; 
var max = 4;

// 1. define 4 rows across (loop #1)
// three parts to a loop:
	// 1. counter, a.k.a. minimum
	// 2. ceiling, i.e. "count until"
	// 3. increase the counter
for ( r = min; r < max; r++ ) {
	
	console.log( 'row ---', r );

	// 2. within each row, define 4 columns (loop #2)
	for ( c = min; c < max; c++ ) {
		
		console.log( 'column', c );

		// 3. add a square here!
		xxAddSquare(r,c);

	} // end columns

} // end rows


// 3. create a function that adds squares to the HTML body
function xxAddSquare(row,col) {

	console.log('xxAddSquare');

	// variable we store the HTML square in
	var square = "";
	// variable that we store our CSS class names in
	var squareClass = "";

	// this is where logic happens to make the pattern
	// change the order of the `else if` statements and see how the pattern changes
	
	// b. corner squares
	// target all the extremeties. NOTE: because our loop is defined by evaluating whether or not the counter is less than max, we need to SUBTRACT 1 from the max in order to get the outer square
	if ( row == min && col == min 
		|| row == (max-1) && col == (max-1)
		|| row == min && col == (max-1)
		|| row == (max-1) && col == min
		) {
		squareClass = "demo-circle";
	}

	// a. diagonal squares
	// row is equal to column ... 
	else if ( row == col ) {
		squareClass = "demo-circle";
	}

	// c. even columns
	// if remainder of column / 2 is equal to 0 ... 
	else if ( col % 2 == 0 ) {
		squareClass = "demo-square";
	}

	// d. odd columns
	// if remainder of column / 2 is equal to 1 ... 
	else if ( col % 2 == 1 ) {
		squareClass = "demo-lozenge";
	}

	else { 
		// do nothing :)
	}

	// build our square tile
	square = '<div class="square xx '+squareClass+'"><div></div></div>';

	// add our square to the document
	document.write( square );

} // end xxAddSquare()










